/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
* Operator of Los Alamos National Laboratory.
* This file is distributed subject to a Software License Agreement found
* in the file LICENSE that is included with this distribution. 
\*************************************************************************/
package dbStatic;
import java.lang.* ;
import java.io.*;

public class DbBase extends Object{

    public DbBase()
    {
	indexDbBase = -1;
	alloc();
    }
    public native final void free();
    public void readDatabase (String filename) 
    {
	readDatabase(filename,null,null);
    }
    public void readDatabase(String filename,String path) 
    {
	readDatabase(filename,path,null);
    }
    public native final void readDatabase
	(String filename, String path, String substitutions);

    public native final void path (String path);
    public native final void addPath (String path);

    public native final void writeMenu
	(String filename, String menuName);
    public native final void writeRecordType
	(String filename, String recordTypeName);
    public native final void writeDevice (String filename);
    public native final void writeDriver (String filename);
    public native final void writeBreaktable(String filename);
   
    public void writeRecord(String filename) 
    {
        writeRecord(filename,"",0);
    }
    public void writeRecord(String filename,String recordTypename)
    {
	writeRecord(filename,recordTypename,0);
    }
    public native final void writeRecord
	(String filename, String recordTypename,int level);
    int indexDbBase;
    public native final void dumpPath();
    public native final void dumpRecord
	(String precordTypeName, int level);
    public native final void dumpMenu(String menuName);
    public native final void dumpRecordType(String recordTypeName);
    public native final void dumpFldDes(String recordTypeName, String
fname);
    public native final void dumpDevice(String recordTypeName);
    public native final void dumpDriver();
    public native final void dumpBreaktable(String name);
    public native final void pvdDump(int verbose);
    public native final void reportDeviceConfig(String report);
    protected void finalize() {
	free();
    }
    private native final void alloc();
    static {
        System.loadLibrary("dbStatic");
    }
}
